ENTITY adder2 is
	PORT (
		a, b : in bit_vector(3 downto 0);
		c,d : out bit_vector(0 to 7)
	);
END adder2;

ENTITY segmentencoder IS
	PORT (
		a: in bit_vector(3 downto 0);
		b, c: out bit_vector(0 to 7)
	);
END segmentencoder;

ARCHITECTURE arc_segenc OF segmentencoder IS
BEGIN
	WITH a SELECT
		b <=	"00000011" WHEN "0000", --0
			"00000011" WHEN "1010", --10
			"10011111" WHEN "0001", --1
			"10011111" WHEN "1011", --11
			"00100101" WHEN "0010", --2
			"00100101" WHEN "1100", --12
			"00001101" WHEN "0011", --3
			"00001101" WHEN "1101", --13
			"10011001" WHEN "0100", --4
			"10011001" WHEN "1110", --14
			"01001001" WHEN "0101", --5
			"01001001" WHEN "1111", --15
			"01000001" WHEN "0110", --6
			"00011111" WHEN "0111", --7
			"00000001" WHEN "1000", --8
			"00001001" WHEN "1001", --9
			"01100001" WHEN others; --E
	WITH a SELECT
		c <=	"10011111" WHEN "1010", -- 10
			"10011111" WHEN "1011", -- 11
			"10011111" WHEN "1100", -- 12
			"10011111" WHEN "1101", -- 13
			"10011111" WHEN "1110", -- 14
			"10011111" WHEN "1111", -- 15
			"11111111" WHEN others; -- leer
END;

ARCHITECTURE adder2_arch of adder2 is
	SIGNAL x, y, z: bit_vector(3 downto 0);
	SIGNAL m,n: bit_vector(0 to 7);

	COMPONENT segmentencoder IS
		PORT(
			a: in bit_vector(3 downto 0);
			b,c: out bit_vector(0 to 7));
	END COMPONENT;
BEGIN
	PORTMAP: segmentencoder PORT MAP (z, m, n); -- erstellt aus Ergebnis z Ziffer 1 (n) und 2 (m)
	x <= NOT a;
	y <= NOT b;
	PROCESS(a, b)
	VARIABLE
		cin : bit;
	BEGIN
		cin := '0';
		FOR i IN 0 TO 3 LOOP
			z(i) <= (x(i) XOR y(i)) XOR cin;
			cin := (x(i) AND y(i)) OR (x(i) AND cin) OR (y(i) AND cin);
		END LOOP;

		IF cin = '1' THEN
			d <= "11111111"; -- leer
			c <= "01100001"; -- E
		ELSE
			c <= m;
			d <= n;
		END IF;
	END PROCESS;
END adder2_arch;
